module RubyConnman
  class Manager
    attr_accessor :service_interface

    def initialize
      @service_interface = DBus::SystemBus.instance.service('net.connman').object('/')
      @service_interface.introspect
      @service_interface = @service_interface['net.connman.Manager']
    end

    def scan
      interfaces = @service_interface.GetTechnologies.first.select { |a| a[1]['Type'] == 'wifi' }
      interfaces.each do |interface|
        RubyConnman::Technology.new(interface[0]).service_interface.Scan
      end
    end

    def wifi_services
      temp = []
      interfaces = @service_interface.GetServices.first.select { |a| a[1]['Type'] == 'wifi' }
      interfaces.each do |interface|
        #RubyConnman::Service.new(interface[0])
        temp.push([interface[0], interface[1]])
      end
      temp
    end

    def get_interface(network_interface)
      interface = @service_interface.GetServices.first.select { |a| a[1]['Ethernet']['Interface'] == network_interface }
      (interface.empty?) ? nil : interface.first
    end
  end
end